Part Torus: Difference between revisions

From FreeCAD Documentation
m (Delete example from scripting section.)
(typo)
 
(17 intermediate revisions by 2 users not shown)
Line 23: Line 23:


<!--T:2-->
<!--T:2-->
The [[Image:Part_Torus.svg|24px]] '''Part Torus''' command creates a parametric torus solid, a doughnut shape. It is the result of sweeping a circular profile around a circular path. In the coordinate system defined by its {{PropertyData|Placement}} property, the circular path of the torus lies on the XY plane with its center at the origin.
Creates a simple parametric torus, with position, angle1, angle2, angle3, radius1 and radius2 as parameters.

<!--T:26-->
A Part Torus can be turned into a segment of a torus by changing its {{PropertyData|Angle3}} property. By changing its {{PropertyData|Angle1}} and/or {{PropertyData|Angle2}} properties the swept profile can become a segment of a circle.


</translate>
</translate>
[[File:Part Torus Example.png]]
[[Image:Part_Torus_Example.png|400px]]
<translate>
<translate>


Line 32: Line 35:


<!--T:5-->
<!--T:5-->
# Switch to the [[Image:Workbench_Part.svg|16px]] [[Part_Workbench|Part Workbench]]
# There are several ways to invoke the command:
# There are several ways to invoke the command:
#* Press the {{Button|[[Image:Part_Torus.svg|16px]] Torus}} button in the toolbar.
#* Press the {{Button|[[Image:Part_Torus.svg|16px]] [[Part_Torus|Part Torus]]}} button.
#* Select the {{MenuCommand|Part → Primitives → [[Image:Part_Torus.svg|16px]] Torus}} from the menu bar.
#* Select the {{MenuCommand|Part → Primitives → [[Image:Part_Torus.svg|16px]] Torus}} option from the menu.
# The torus is created.
# Optionally change the dimensions and {{PropertyData|Placement}} of the torus by doing one of the following:
#* Double-click the object in the [[Tree_view|Tree view]]:
#*# The {{MenuCommand|Geometric Primitives}} task panel opens.
#*# Change one or more properties.
#*# The object is dynamically updated in the [[3D_view|3D view]].
#*# Press the {{Button|OK}} button.
#* Change the properties in the [[Property_editor|Property editor]].
#* Change the {{PropertyData|Placement}} with the [[Image:Std_TransformManip.svg|16px]] [[Std_TransformManip|Std TransformManip]] command.


== Example == <!--T:27-->


<!--T:21-->
<!--T:28-->
[[Image:Part_Torus_Scripting_Example.png|thumb|Part Torus from the scripting example]]
'''Result:''' The torus will be positioned at origin (point 0,0,0) on creation.<br />
The angle parameters (angle1, angle2, angle3), as well as the radius parameters (radius1, radius2) permit to parametrize the torus, see next section.


<!--T:29-->
== Example ==
A Part Torus object created with the [[#Scripting|scripting example]] below is shown here.


== Notes == <!--T:30-->
[[File:Part Torus Scripting Example.png|thumb|Part Torus scripting example.]]


<!--T:31-->
A Part Torus object with the values of the bottom scripting example are shown here.
* A Part Torus can also be created with the [[Image:Part_Primitives.svg|16px]] [[Part_Primitives|Part Primitives]] command. With that command you can specify the dimensions and placement at creation time.


== Option == <!--T:6-->
== Properties == <!--T:11-->


<!--T:16-->
<!--T:32-->
See also: [[Property_editor|Property editor]].
[[File:TorusExampleOverviewParameters.jpg]]


<!--T:7-->
<!--T:33-->
A Part Torus object is derived from a [[Part_Feature|Part Feature]] object and inherits all its properties. It also has the following additional properties:
'''Parameter'''


<!--T:8-->
=== Data === <!--T:34-->
A torus can be assimilated to a small disc that makes a circular orbit around an imaginary axe. Thus the parametric torus is defined by the following parameters:


<!--T:35-->
{{TitleProperty|Attachment}}

<!--T:36-->
The object has the same attachment properties as a [[Part_Part2DObject#Data|Part Part2DObject]].

<!--T:37-->
{{TitleProperty|Torus}}
{{TitleProperty|Torus}}


<!--T:9-->
<!--T:9-->
* {{PropertyData|Radius1|Length}}: Radius of the circle around which the disc circulate
* {{PropertyData|Radius1|Length}}: The radius of the circular path of the torus. The default is {{Value|10mm}}.
* {{PropertyData|Radius2|Length}}: Radius of the disc defining the form of the torus
* {{PropertyData|Radius2|Length}}: The radius of the circular profile of the torus. The default is {{Value|2mm}}.
* {{PropertyData|Angle1|Angle}}: 1st angle to cut / define the disc of the torus
* {{PropertyData|Angle1|Angle}}: The start angle of the circular profile. Valid range: {{Value|-180° &lt;&#61; value &lt;&#61; 180°}}. The default is {{Value|-180°}}.
* {{PropertyData|Angle2|Angle}}: 2nd angle to cut / define the disc of the torus
* {{PropertyData|Angle2|Angle}}: The end angle the circular profile. Valid range: {{Value|-180° &lt;&#61; value &lt;&#61; 180°}}. The default is {{Value|180°}}. If the total angle of the circular profile is smaller than {{Value|360°}} the profile will have a pie-shape.
* {{PropertyData|Angle3|Angle}}: 3rd angle to define the circumference of the torus.
* {{PropertyData|Angle3|Angle}}: The angle of the circular path of the torus. Valid range: {{Value|0° &lt; value &lt;&#61; 360°}}. The default is {{Value|360°}}. If it is smaller than {{Value|360°}} the resulting solid will be a segment of a torus.


<!--T:10-->
== Scripting == <!--T:23-->
As well as the standard set of placement parameters. The pictures below give a visual overview of the parameters antecedently mentioned:


<!--T:11-->
<!--T:38-->
See also: [https://freecad.github.io/SourceDoc/ Autogenerated API documentation], [[Part_scripting|Part scripting]] and [[FreeCAD_Scripting_Basics|FreeCAD Scripting Basics]].
[[File:TorusExampleRadius1.jpg]]
The parameter Radius1 has a value of 20 mm.

<!--T:12-->
[[File:TorusExampleRadius2.jpg]]
The parameter Radius2 has a value of 2 mm.

<!--T:13-->
[[File:TorusExampleAngle1.jpg]]
The parameter Angle1 has a value of -90°. Notice that, the 'angle measure' tool cannot display negative angle. Considered the displayed value in picture as '-90°'.

<!--T:14-->
[[File:TorusExampleAngle2.jpg]]
The parameter Angle2 has a value of 90°.

<!--T:15-->
[[File:TorusExampleAngle3.jpg]]
The parameter Angle3 has a value of 90°.
{{clear}}

== Scripting == <!--T:23-->


<!--T:24-->
<!--T:24-->
A Part Torus can be created using the following function:
A Part Torus can be created with the {{Incode|addObject()}} method of the document:


</translate>
</translate>
Line 104: Line 102:


<!--T:25-->
<!--T:25-->
* Where {{Incode|myTorus}} is the Label for the object.
* Where {{Incode|"myTorus"}} is the name for the object.
* The function returns the newly created object.
* The function returns the newly created object.


<!--T:39-->
The Label of the object can be easily changed by
Example:


</translate>
</translate>
{{Code|code=
{{Code|code=
import FreeCAD as App
torus.Label = "new torusLabelText"
}}
<translate>


doc = App.activeDocument()
You can access and modify attributes of the {{Incode|torus}} object. For example, you may wish to modify the radii or angle parameters.


torus = doc.addObject("Part::Torus", "myTorus")
</translate>
{{Code|code=
torus.Radius1 = 20
torus.Radius1 = 20
torus.Radius2 = 10
torus.Radius2 = 10
Line 124: Line 120:
torus.Angle2 = 45
torus.Angle2 = 45
torus.Angle3 = 270
torus.Angle3 = 270
torus.Placement = App.Placement(App.Vector(1, 2, 3), App.Rotation(30, 45, 10))

doc.recompute()
}}
}}
<translate>
<translate>


The result will be a three-quarter torus.

You can change its placement and orientation with:

</translate>
{{Code|code=
torus.Placement = FreeCAD.Placement(FreeCAD.Vector(1, 2, 3), FreeCAD.Rotation(30, 45, 10))
}}
<translate>


<!--T:18-->
<!--T:18-->
Line 148: Line 138:


</translate>
</translate>
{{Part Tools navi{{#translation:}}}}
{{Part_Tools_navi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}

Latest revision as of 08:56, 4 March 2022

Part Torus

Menu location
Part → Primitives → Torus
Workbenches
Part
Default shortcut
None
Introduced in version
-
See also
Part Primitives

Description

The Part Torus command creates a parametric torus solid, a doughnut shape. It is the result of sweeping a circular profile around a circular path. In the coordinate system defined by its DataPlacement property, the circular path of the torus lies on the XY plane with its center at the origin.

A Part Torus can be turned into a segment of a torus by changing its DataAngle3 property. By changing its DataAngle1 and/or DataAngle2 properties the swept profile can become a segment of a circle.

Usage

  1. There are several ways to invoke the command:
    • Press the Part Torus button.
    • Select the Part → Primitives → Torus option from the menu.
  2. The torus is created.
  3. Optionally change the dimensions and DataPlacement of the torus by doing one of the following:
    • Double-click the object in the Tree view:
      1. The Geometric Primitives task panel opens.
      2. Change one or more properties.
      3. The object is dynamically updated in the 3D view.
      4. Press the OK button.
    • Change the properties in the Property editor.
    • Change the DataPlacement with the Std TransformManip command.

Example

Part Torus from the scripting example

A Part Torus object created with the scripting example below is shown here.

Notes

  • A Part Torus can also be created with the Part Primitives command. With that command you can specify the dimensions and placement at creation time.

Properties

See also: Property editor.

A Part Torus object is derived from a Part Feature object and inherits all its properties. It also has the following additional properties:

Data

Attachment

The object has the same attachment properties as a Part Part2DObject.

Torus

  • DataRadius1 (Length): The radius of the circular path of the torus. The default is 10mm.
  • DataRadius2 (Length): The radius of the circular profile of the torus. The default is 2mm.
  • DataAngle1 (Angle): The start angle of the circular profile. Valid range: -180° <= value <= 180°. The default is -180°.
  • DataAngle2 (Angle): The end angle the circular profile. Valid range: -180° <= value <= 180°. The default is 180°. If the total angle of the circular profile is smaller than 360° the profile will have a pie-shape.
  • DataAngle3 (Angle): The angle of the circular path of the torus. Valid range: 0° < value <= 360°. The default is 360°. If it is smaller than 360° the resulting solid will be a segment of a torus.

Scripting

See also: Autogenerated API documentation, Part scripting and FreeCAD Scripting Basics.

A Part Torus can be created with the addObject() method of the document:

torus = FreeCAD.ActiveDocument.addObject("Part::Torus", "myTorus")
  • Where "myTorus" is the name for the object.
  • The function returns the newly created object.

Example:

import FreeCAD as App

doc = App.activeDocument()

torus = doc.addObject("Part::Torus", "myTorus")
torus.Radius1 = 20
torus.Radius2 = 10
torus.Angle1 = -90
torus.Angle2 = 45
torus.Angle3 = 270
torus.Placement = App.Placement(App.Vector(1, 2, 3), App.Rotation(30, 45, 10))

doc.recompute()